const name = Symbol.for('name')
const value = Symbol.for('value')
const keyQuote = Symbol.for('keyQuote')
const valueQuote = Symbol.for('valueQuote')
const isBind = Symbol.for('isBind')
const colon = "'"
const quote = '"'

function randomWord(randomFlag, min, max) {
    var str = "",
        range = min,
        arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];

    // 随机产生
    if (randomFlag) {
        range = Math.round(Math.random() * (max - min)) + min;
    }
    for (let i = 0; i < range; i++) {
        let pos = Math.round(Math.random() * (arr.length - 1));
        str += arr[pos];
    }
    return str;
}


function concatHtmlWithTagAndAttrs(tag, attrs, content,recursive) {
    if(!recursive){
        recursive = false
    }
    let tagContent = ''
    if (content) {
        tagContent = content
    }
    let values = []
    if (attrs && typeof attrs === 'object') {
        if (Array.isArray(attrs)) {
            for (let attr of attrs) {
                let attrStr = concatHtmlWithTagAndAttrs(tag, attr, content,true)
                if (attrStr && attrStr !== '') {
                    values.push(attrStr)
                }
            }
        } else {
            let attrHtml = AttrBuilder(attrs)
            values.push(attrHtml)
        }

    }
    if (tagContent && !recursive) {
        return `<${tag}  `+ values.join(' ') + `>${tagContent}</${tag}>`
    } else {
        if (tag && !recursive) {
            return `<${tag} ` + values.join(' ') + ` />`
        } else {
            return values.join(' ')
        }
    }

    return ''
}

function AttrBuilder(attrs) {
    let template = ''
    if (attrs[isBind]) {
        template = template + ':'
    }
    template = template + `${attrs[keyQuote]}${attrs[name]}${attrs[keyQuote]}`
    if (attrs[valueQuote]) {
        template = template + '=' + `${attrs[valueQuote]}${attrs[value]}${attrs[valueQuote]}`
    }
    return template
}

const uid = function () {
    return Date.now().toString(36) + Math.random().toString(36).substr(2);
}
export {name, value, keyQuote, valueQuote, isBind, quote, colon, concatHtmlWithTagAndAttrs, uid, randomWord}